<template>
    <div class="first-style-container">
        <div class="row items-center">
            <div
                v-for="(offer, index) in popup.growth_offers"
                v-if="offer.status"
                :key="index"
                class="col-md-4 col-sm-4 col-xs-4 gift-size-container"
            >
                <div
                    v-if="popup.growth_offers[0].optin_channel !== 'any' && offer.order != 1"
                    class="blur"
                >
                    <div v-if="popup.popup_background_type == 2" />
                    <div
                        v-else
                        class="blur"
                        :style="{backgroundColor: popup.colors.settings_background + 'cc'}"
                    />
                </div>
                <span v-if="popup.icon_style == 1">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/gift1_opened.svg'"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/Gift1.svg'"
                    >
                </span>
                <span v-if="popup.icon_style == 2">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/opened_sgift-2.svg'"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/gift_1.svg'"
                    >
                </span>
                <span v-if="popup.icon_style == 3">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/gift3_opened.svg'"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="'/images/present-box-2.svg'"
                    >
                </span>
                <span v-if="popup.icon_style == 4">
                    <img
                        v-if="offer.order < 3"
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="popup.popup_image"
                    >
                    <img
                        v-else
                        :class="deviceType === 0 ? 'gift-size-' + offer.order: 'mobile-gift-size-' + offer.order"
                        :src="popup.popup_image_closed"
                    >
                </span>
            </div>
        </div>
        <div
            v-if="activeOffers == 3"
            class="row justify-content-center items-center"
        >
            <div
                class="col-md-4 line1"
                :style="{backgroundColor: popup.colors.progress_bar_color}"
            >
                <div
                    class="start-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
                <div
                    class="end-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
            </div>
            <div class="col-md-4 line2">
                <div class="end-circle" />
            </div>
        </div>
        <div
            v-if="activeOffers == 2"
            class="row justify-content-center items-center"
        >
            <div
                class="col-md-4 line1"
                :style="{backgroundColor: popup.colors.progress_bar_color}"
            >
                <div
                    class="start-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
                <div
                    class="end-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
            </div>
        </div>
        <div
            v-if="activeOffers == 1"
            class="row justify-content-center items-center"
        >
            <div class="col-md-4">
                <div
                    class="last-circle"
                    :style="{backgroundColor: popup.colors.progress_bar_color}"
                />
            </div>
        </div>

        <div class="row items-center discount-preview-container">
            <div
                v-for="offer in popup.growth_offers"
                v-if="offer.status"
                class="gift-container"
                :style="{color: popup.colors.progress_bar_color}"
                :class="{'col-lg-12': deviceType === 1, 'col-md-4': deviceType === 0}"
            >
                {{ offer.automatic_discount_value }}%
            </div>
        </div>

        <div class="row mt-20 items-center">
            <div
                v-for="offer in popup.growth_offers"
                v-if="offer.status"
                class="gift-container"
                :class="{'col-lg-12': deviceType === 1, 'col-md-4': deviceType === 0}"
            >
                <div
                    v-if="popup.growth_offers[0].optin_channel !== 'any' && offer.order != 1"
                    class="blur"
                >
                    <div v-if="popup.popup_background_type == 2" />
                    <div
                        v-else
                        class="blur"
                        :style="{backgroundColor: popup.colors.settings_background + 'cc'}"
                    />
                </div>
                <div>
                    <!--        <div :style="{color: offer.text_color}" class="title">{{ offer.offer_text }}</div>-->
                    <div
                        class="action-gift-container"
                        :style="{backgroundColor: offer.background_color}"
                    >
                        <div
                            v-if="!showThank[offer.order - 1].active"
                            :style="{color: offer.text_color}"
                            class="title"
                        >
                            {{ replaceShortcodes(offer.offer_text, offer.automatic_discount_value) }}
                        </div>
                        <div
                            v-if="offerTypes[offer.order-1] === 'email'"
                            :class="{'full-height': showThank[offer.order - 1].active}"
                        >
                            <div
                                v-if="showThank[offer.order - 1].active"
                                class="full-width full-height"
                            >
                                <div
                                    :id="`thank-text-${offer.order-1}`"
                                    class="thank-you-message-container"
                                >
                                    <div
                                        v-html="replaceShortcodes(offer.thank_message, offer.automatic_discount_value, offer.order)"
                                    />
                                </div>
                            </div>
                            <div class="sms-phone-container">
                                <div
                                    v-if="!showThank[offer.order - 1].active"
                                    class="growth-input-container"
                                >
                                    <div
                                        class="growth-input-icon-container"
                                        :style="{backgroundColor:offer.icon_background_color}"
                                    >
                                        <IconEmail
                                            class="growth-action-icons"
                                            :color="offer.icon_color"
                                        />
                                    </div>
                                    <input
                                        name="password"
                                        :placeholder="offer.placeholder_text !== null ? offer.placeholder_text : 'Your email address'"
                                        class="email-input"
                                    >
                                </div>
                            </div>
                            <div>
                                <button
                                    v-if="!showThank[offer.order - 1].active"
                                    :style="{backgroundColor: offer.btn_color, color: offer.btn_text_color}"
                                    class="btn get-discount-btn-full"
                                >
                                    {{ offer.btn_text }}
                                </button>
                            </div>
                        </div>
                        <div
                            v-if="offerTypes[offer.order-1] === 'sms'"
                            :class="{'full-height': showThank[offer.order - 1].active}"
                        >
                            <div
                                v-if="showThank[offer.order - 1].active"
                                class="full-width full-height"
                            >
                                <div
                                    :id="`thank-text-${offer.order-1}`"
                                    class="thank-you-message-container"
                                >
                                    <div
                                        v-html="replaceShortcodes(offer.thank_message, offer.automatic_discount_value, offer.order)"
                                    />
                                </div>
                            </div>
                            <div class="sms-phone-container">
                                <div
                                    v-if="!showThank[offer.order - 1].active"
                                    class="growth-input-container"
                                >
                                    <div
                                        class="growth-input-icon-container"
                                        :style="{backgroundColor: offer.icon_background_color}"
                                    >
                                        <IconSms
                                            class="growth-action-icons"
                                            :color="offer.icon_color"
                                        />      
                                    </div>

                                    <input
                                        type="number"
                                        name="password"
                                        :placeholder="offer.placeholder_text !== null ? offer.placeholder_text : 'Your phone number'"
                                        class="email-input"
                                    >
                                </div>
                            </div>
                            <div>
                                <button
                                    v-if="!showThank[offer.order - 1].active"
                                    :style="{backgroundColor: offer.btn_color, color: offer.btn_text_color}"
                                    class="btn get-discount-btn-full"
                                >
                                    {{ offer.btn_text }}
                                </button>
                            </div>
                        </div>
                        <div
                            v-if="offerTypes[offer.order-1] === 'push'"
                            :class="{'full-height': showThank[offer.order - 1].active}"
                        >
                            <div
                                v-if="showThank[offer.order - 1].active"
                                class="full-width full-height"
                            >
                                <div
                                    :id="`thank-text-${offer.order-1}`"
                                    class="thank-you-message-container"
                                >
                                    <div
                                        v-html="replaceShortcodes(offer.thank_message, offer.automatic_discount_value, offer.order)"
                                    />
                                </div>
                            </div>
                            <div class="sms-phone-container">
                                <div
                                    v-if="!showThank[offer.order - 1].active"
                                    class="growth-input-container"
                                >
                                    <div
                                        class="growth-input-icon-container"
                                        :style="{backgroundColor:offer.icon_background_color}"
                                    >
                                        <IconPush
                                            class="growth-action-icons"
                                            :color="offer.icon_color"
                                        />
                                    </div>
                                    <div
                                        id="growth-push-text"
                                        class="push-text"
                                    >
                                        {{ offer.placeholder_text !== null ? offer.placeholder_text : 'Push notification' }}
                                    </div>
                                </div>
                            </div>
                            <div>
                                <button
                                    v-if="!showThank[offer.order - 1].active"
                                    :style="{backgroundColor: offer.btn_color, color: offer.btn_text_color}"
                                    class="btn get-discount-btn-full"
                                >
                                    {{ offer.btn_text }}
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import IconPush from '@/components/growth-tools/new/icons/Push.vue'
import IconSms from '@/components/growth-tools/new/icons/Sms.vue'
import IconEmail from '@/components/growth-tools/new/icons/Email.vue'

export default {
    components: {
        IconPush,
        IconEmail,
        IconSms,
    },
    props: ['popup', 'deviceType', 'showThank', 'activeOffers'],
    data() {
        return {
            offerTypes: [],
            anyType: '',
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
        }
    },
    computed: {
        isFirst() {

        }
    },
    watch: {
        popup: {
            deep: true,
            handler() {
                this.offerTypes = [];
                this.popup.growth_offers.map(offer => {
                    this.offerTypes.push(offer.optin_channel);
                });
                this.getTypeFromAny();
            }
        },
    },
    mounted() {
        this.offerTypes = [];
        this.popup.growth_offers.map(offer => {
            this.offerTypes.push(offer.optin_channel);
        });
        this.getTypeFromAny();
    },
    methods: {
        replaceShortcodes(text, value = '', order = 1) {
            if (text) {
                text = text.replace(/{discountValue}/g, value);
                const currentOffer = this.popup.growth_offers[order-1]
                const thankCode = currentOffer.automatic_discount_enabled == 1 ? this.code : currentOffer.code
                text = text.replace(/{discountCode}/g, `<span class="preview-thank-code">${thankCode || 'enter code'}</span>`);
            }
            return text;
        },
        getTypeFromAny() {
            const allValues = ["email", "sms", "push"];
            let difference = allValues.filter(x => this.offerTypes.indexOf(x) == -1);
            let k = 0;
            for (let i = 0; i < 4; i++) {
                if (this.offerTypes[i] === 'any') {
                    this.anyType = this.offerTypes[i]
                    this.offerTypes[i] = difference[k];
                    k++;
                }
            }
        },
    }
}
</script>

<style scoped lang="scss">

.discount-preview-container {
    margin-top: 5px !important;
    font-weight: bold;
}

.thank-you-message-container {
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: space-between;

    div {
        display: flex;
        height: 100%;
        flex-direction: column;
        justify-content: center;
    }
}

.action-gift-container {
    height: 130px !important;
}

input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
    -webkit-appearance: none;
    margin: 0;
}

.full-height {
    height: 100%;
    min-height: 100% !important;
}

.last-circle {
    width: 10px;
    height: 10px;
    border-radius: 50%;
    position: absolute;
    top: -4.5px;
    left: calc(50% - 5px);
}

.start-circle {
    width: 10px;
    height: 10px;
    border-radius: 50%;
    position: absolute;
    top: -4.5px;
    left: -5px;
}

.end-circle {
    width: 10px;
    z-index: 10;
    height: 10px;
    border-radius: 50%;
    position: absolute;
    top: -4.5px;
    right: -5px;
    background-color: #E5E5E5;
}

.line1 {
    height: 2px;
}

.line2 {
    height: 2px;
    background-color: #E5E5E5;
}

input[type=number] {
    -moz-appearance: textfield;
}

.push-text {
    font-size: 12px;
    width: max-content;
    text-align: initial;
    padding-left: 15px;
}

.gift-size-container {
    display: flex;
    justify-content: center;
    align-items: flex-end;
    height: 80px;
}


.growth-action-icons {
    width: 15px;
}

.first-style-container {
    display: flex;
    flex-direction: column;
}

.title {
    font-size: 14px;
    margin-bottom: 10px;
    font-weight: 500;
    @media screen and (max-width: 1200px) {
        font-size: 12px;
    }
}

.growth-input-container {
    display: flex;
    align-items: center;
    width: 100%;
}

.blur {
    position: absolute;
    height: 100%;
    width: 100%;
    cursor: not-allowed;
    z-index: 2;
}

.items-center {
    display: flex;
    justify-content: center;
}

.actions {
  font-size: 14px;
  line-height: 16px;
  display: flex;
  flex-direction: column;
  height: 144px;
  &__item {
    display: flex;
    align-items: center;
    margin-bottom: 16px;
  }
  &__input,
  &__type,
  &__btn {
    display: flex;
    align-items: center;
    justify-content: center;
    height: 36px;
  }
}
</style>
